<?php
#
# ===========================================================================
#
# Class for Benchmark Table Management
#
# Date: 06 August 2002
# Author: J.Delamarche
#
# ---------------------------------------------------------------------------
#
# TODO: an new function that contains the last DB error
#		
# ===========================================================================
#
include_once "util.inc.php";

# ===================================================
# All the database interface are defined as a 
# class with the following methods:
#
# XXX_connect($server,$user,$pwd,$db)
# XXX_QueryExecute($query)
# XXX_QueryAndFetchRows($query)
# XXX_QueryAndFetchaRow($query)
# XXX_LastError()
# XXX_SQLErrorLog($text)
#
# Since SQL language are different, we must
# implement some small methods that gives the exact
# SQL syntax for the WHERE clause:
#
# XXX_GetHourPart($field)
# XXX_GetMinutePart($field)
# XXX_GetSecondPart($field)
# XXX_GetDayOfWeek($field)
# XXX_GetWeek($field)
# XXX_GetDayOfMonth($field)
# XXX_GetMonth($field)
# XXX_GetYear($field)
# XXX_DateCompare($field,$date1,$date2)
# ===================================================

# ---------------------------------------------------
# MySQL Interface:
# ---------------------------------------------------
class CMySQLInterface
{
	var $m_conn   = NULL;
	var $m_db     = NULL;
	var $m_dbtype = NULL;	// +++++ added on the 22 Aug 2003

	function Connect($server,$user,$pwd,$dbname)
	{
		$this->m_conn = mysql_pconnect($server,$user,$pwd);
		if (!$this->m_conn) {
			$this->SQLErrorLog("Connection to $dbserver failed");
			die("Connexion to $dbserver failed: ".$php_errormsg);
		}

		if (!mysql_select_db($dbname,$this->m_conn)) {
			$this->SQLErrorLog("Database $dbname not found");
			die("Database not found: $dbname".$php_errormsg);
		}

		$this->m_db   = $dbname;
	}

	function QueryExecute($query)
	{
		mysql_select_db($this->m_db,$this->m_conn);
		$result = mysql_query($query,$this->m_conn);
		if (!$result) 
			return 0;
			
		return $result;
	}
	
	function QueryAndFetchRows($query)
	{
		$result = $this->Queryexecute($query);
		if (!$result) return 0;

		$count = 0;
		while ($row = mysql_fetch_array($result)) {
			$items[$count] = $row;
			$count++;
		}

		mysql_free_result($result);

		return $items;
	}

	function QueryAndFetchaRow($query)
	{
		$result = $this->Queryexecute($query);
		if (!$result) return 0;

		$row = mysql_fetch_array($result);

		mysql_free_result($result);

		return $row;
	}

	function LastError()
	{
		return mysql_error();
	}
		
	function SQLErrorLog($text)
	{
		ErrorLog("SQL Error: ".$text);
		ErrorLog("errno=".mysql_errno()." [".mysql_error()."]");
	}

	function GetHourPart($field) 	{ return "HOUR($field)"; }
	function GetMinutePart($field) 	{ return "MINUTE($field)"; }
	function GetSecondPart($field) 	{ return "SECOND($field)"; }
	function GetDayOfWeek($field)	{ return "DAYOFWEEK($field)"; }
	function GetWeek($field) 	{ return "WEEK($field)"; }
	function GetDayOfMonth($field)	{ return "DAYOFMONTH($field)"; }
	function GetMonth($field)	{ return "MONTH($field)"; }
	function GetYear($field)	{ return "YEAR($field)"; }

	function DateCompare($field,$date1,$date2) { return "$field > \"$date1\" AND $field <= \"$date2\""; }
};

# ---------------------------------------------------
# PostgreSQL Interface:
# ---------------------------------------------------
class CPostgreSQLInterface
{
	var $m_conn = NULL;
	var $m_db   = NULL;

	function Connect($server,$user,$pwd,$dbname)
	{
		$this->m_conn = pg_pconnect("host='$server' dbname='$dbname' user='$user' password='$pwd'");
		if (!$this->m_conn) {
			$this->SQLErrorLog("Connection to $dbserver failed");
			die("Connexion to $dbserver failed: ".$php_errormsg);
		}

		$this->m_db   = $dbname;
	}

	function QueryExecute($query)
	{
		$result = pg_query($this->m_conn,$query);
		if (!$result) 
			return 0;
			
		return $result;
	}
	
	function QueryAndFetchRows($query)
	{
		$result = $this->QueryExecute($query);
		if (!$result) return 0;

		$count = 0;
		while ($row = @pg_fetch_array($result,$count)) {
			$items[$count] = $row;
			$count++;
		}

		pg_free_result($result);

		return $items;
	}

	function QueryAndFetchaRow($query)
	{
		$result = $this->QueryExecute($query);
		if (!$result) return 0;

		$row = pg_fetch_array($result);

		pg_free_result($result);

		return $row;
	}

	function LastError()
	{
		return pg_last_error();
	}
		
	function SQLErrorLog($text)
	{
		ErrorLog("SQL Error: ".$text);
		ErrorLog("error=".pg_last_error());
	}

	function GetHourPart($field) 	{ return "date_part('hour',$field)"; }
	function GetMinutePart($field) 	{ return "date_part('min',$field)"; }
	function GetSecondPart($field) 	{ return "date_part('sec',$field)"; }
	function GetDayOfWeek($field)	{ return "date_part('dow',$field)"; }
	function GetWeek($field) 	{ return "date_part('week',$field)"; }
	function GetDayOfMonth($field)	{ return "date_part('day',$field)"; }
	function GetMonth($field)	{ return "date_part('month',$field)"; }
	function GetYear($field)	{ return "date_part('year',$field)"; }

	function DateCompare($field,$date1,$date2) { return "$field > '$date1' AND $field <= '$date2'"; }
};

# ---------------------------------------------------
# Sybase Interface:
#
# Notes:
# Sybase extension sends a lot of WARNING through
# its callback mechanism. We must disable these
# messages...
# ---------------------------------------------------
class CSybaseInterface
{
	var $m_conn = NULL;
	var $m_db   = NULL;
	var $m_loglevel;

	function LowReporting()
	{
		return;
		$this->m_loglevel = error_reporting(0);
		error_reporting($this->m_loglevel & ~E_WARNING);
	}

	function StdReporting()
	{
		return;
		error_reporting($this->m_loglevel);
	}

	function Connect($server,$user,$pwd,$dbname)
	{
		$this->LowReporting();

		$this->m_conn = sybase_connect($server,$user,$pwd);
		if (!$this->m_conn) {
			$this->SQLErrorLog("Connection to $dbserver failed");
			die("Connexion to $dbserver failed: ".$php_errormsg);
		}

		if (!sybase_select_db($dbname,$this->m_conn)) {
			$this->SQLErrorLog("Database $dbname not found");
			die("Database not found: $dbname".$php_errormsg);
		}

		$this->m_db   = $dbname;

		$this->StdReporting();
	}

	function QueryExecute($query)
	{
		$this->LowReporting();
		$result = sybase_query($query,$this->m_conn);
		$this->StdReporting();
		if (!$result) 
			return 0;

		return $result;
	}
	
	function QueryAndFetchRows($query)
	{
		$result = $this->QueryExecute($query);
		if (!$result) 
			return 0;

		$this->LowReporting();
		$count = 0;
		while ($row = sybase_fetch_array($result)) {
			$items[$count] = $row;
			$count++;
		}

		sybase_free_result($result);
		$this->StdReporting();

		return $items;
	}

	function QueryAndFetchaRow($query)
	{
		$result = $this->QueryExecute($query);
		if (!$result) 
			return 0;

		$this->LowReporting();
		$row = sybase_fetch_array($result);
		sybase_free_result($result);
		$this->StdReporting();

		return $row;
	}

	function LastError()
	{
		return ""; // ????
	}
	
	function SQLErrorLog($text)
	{
		ErrorLog("SQL Error: ".$text);
	}

	function GetHourPart($field) 	{ return "datepart(hour,$field)"; }
	function GetMinutePart($field) 	{ return "datepart(minute,$field)"; }
	function GetSecondPart($field) 	{ return "datepart(second,$field)"; }
	function GetDayOfWeek($field)	{ return "datepart(weekday,$field)"; }
	function GetWeek($field) 	{ return "datepart(week,$field)"; }
	function GetDayOfMonth($field)	{ return "datepart(day,$field)"; }
	function GetMonth($field)	{ return "datepart(month,$field)"; }
	function GetYear($field)	{ return "datepart(year,$field)"; }

	function DateCompare($field,$date1,$date2) 
	{ 
		# +++++ fix on the 14 Aug 2003: HH:MM:SS taken in account
		list($y1,$m1,$d1,$h1,$i1,$s1) = split("[-: ]",$date1);
		$m1 = (int)$m1;
		list($y2,$m2,$d2,$h2,$i2,$s2) = split("[-: ]",$date2);
		$m2 = (int)$m2;
		return "$field > \"$m1/$d1/$y1 $h1:$i1:$s1\" AND $field <= \"$m2/$d2/$y2 $h2:$i2:$s2\""; 
	}
};

# ===================================================
# This is the main class that extracts data from 
# the benchmark database
# ===================================================
class CDBBenchmark
{
var $m_int = NULL;
var $m_db  = NULL;

# filter values:
var $m_startdate = "2002-01-01 00:00:00";	// start date for stat computation
var $m_enddate   = "2010-12-31 23:59:59";	// end date
var $m_filterurl = "all";
var $m_threshold = 0;
var $m_servers   = "all";
var $m_protocols = "all";

# common queries:
var $m_avgQuery = Array (
		"apache" => "SELECT AVG(ben_busy) AS value FROM t_benchmark_log",
		"cpu"	 => "SELECT AVG(ben_avgload) AS value FROM t_benchmark_log",
		"mem"	 => "SELECT AVG(ben_memuse) AS value FROM t_benchmark_log",
		"swap"	 => "SELECT AVG(ben_swapuse) AS value FROM t_benchmark_log",
		"time"   => "SELECT AVG(ben_sec * 1000 + ben_usec / 1000) AS value FROM t_benchmark_log",
		"alert"  => "SELECT COUNT(*) AS value FROM t_benchmark_alert",
		);

var $m_maxQuery = Array (
		"apache" => "SELECT MAX(ben_busy) AS value FROM t_benchmark_log",
		"cpu"	 => "SELECT MAX(ben_avgload) AS value FROM t_benchmark_log",
		"mem"	 => "SELECT MAX(ben_memuse) AS value FROM t_benchmark_log",
		"swap"	 => "SELECT MAX(ben_swapuse) AS value FROM t_benchmark_log",
		"time"   => "SELECT MAX(ben_sec * 1000 + ben_usec / 1000) AS value FROM t_benchmark_log",
		"alert"  => "SELECT COUNT(*) AS value FROM t_benchmark_alert",
		);

var $m_minQuery = Array (
		"apache" => "SELECT MIN(ben_busy) AS value FROM t_benchmark_log",
		"cpu"	 => "SELECT MIN(ben_avgload) AS value FROM t_benchmark_log",
		"mem"	 => "SELECT MIN(ben_memuse) AS value FROM t_benchmark_log",
		"swap"	 => "SELECT MIN(ben_swapuse) AS value FROM t_benchmark_log",
		"time"   => "SELECT MIN(ben_sec * 1000 + ben_usec / 1000) AS value FROM t_benchmark_log",
		"alert"  => "SELECT COUNT(*) AS value FROM t_benchmark_alert",
		);

# ----------
# Ctor:
# ----------
function CDBBenchmark($dbtype, $dbname = "benchmark", $dbserver = NULL, $dbuser = NULL, $dbpwd = NULL) 
{
	$this->m_db     = $dbname;
	$this->m_dbtype = $dbtype;

	if ($dbtype == "MySQL")
		$this->m_int = new CMySQLInterface();
	elseif ($dbtype == "Sybase")
		$this->m_int = new CSybaseInterface();
	elseif ($dbtype == "PostgreSQL")
		$this->m_int = new CPostgreSQLInterface();
	else die("Database '$dbtype' not supported\n");

	$this->m_int->Connect($dbserver,$dbuser,$dbpwd,$dbname);
}

# ---------------------
# Return the last error:
# ---------------------
function LastError()
{
	return $this->m_int->LastError();
}

# ---------------------------------------------------------
# Used by the menu to display the list of all available URL:
# ---------------------------------------------------------
function GetURLList()
{
	$query = "SELECT DISTINCT url_value FROM t_benchmark_log ORDER BY url_value ASC";
	$result = $this->m_int->QueryAndFetchRows($query);
	if (!$result) {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GetURLList() failed");
		return 0;
	}

	return $result;
}

# -------------------------------------------------------------
# Used by the menu to display the list of all available Servers:
# -------------------------------------------------------------
function GetServerList()
{
	$query = "SELECT DISTINCT ben_srvaddr FROM t_benchmark_log ORDER BY ben_srvaddr ASC";
	$result = $this->m_int->QueryAndFetchRows($query);
	if (!$result) {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GetServerList() failed");
		return 0;
	}

	return $result;
}

# ---------------------------------------------------------------
# Used by the menu to display the list of all available Protocols:
# ---------------------------------------------------------------
function GetProtocolList()
{
	$query = "SELECT DISTINCT ben_srvport FROM t_benchmark_log ORDER BY ben_srvport ASC";
	$result = $this->m_int->QueryAndFetchRows($query);
	if (!$result) {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GetProtocolList() failed");
		return 0;
	}

	return $result;
}

# =================================================
# Stored Graph Management:
# =================================================

# ----------------------------------------------
# Return the content of t_benchmark_graph table:
# ----------------------------------------------
function GetGraphList()
{
	$query = "SELECT * FROM t_benchmark_graph ORDER BY gra_date DESC";
	$result = $this->m_int->QueryAndFetchRows($query);
	if (!$result) {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GetGraphList() failed");
		return 0;
	}

	return $result;
}

# ----------------------------
# Retrieve the specified Graph:
# ----------------------------
function GraphGet($grid)
{
	$grid = SQLMakeIntSafe($grid);
	
	$query = "SELECT * FROM t_benchmark_graph WHERE gra_id = $grid";
	$result = $this->m_int->QueryAndFetchaRow($query);
	if (!$result) {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GraphGet($grid) failed");
		return 0;
	}
	
	$result["gra_name"] = stripslashes($result["gra_name"]);
	$result["gra_note"] = stripslashes($result["gra_note"]);
	$result["gra_blob"] = stripslashes($result["gra_blob"]);
	
	// +++++ added on the 22 Aug 2003:
	if ($this->m_dbtype == "Sybase") {
		$result["gra_name"] = ereg_replace("''","'",$result["gra_name"]);
		$result["gra_note"] = ereg_replace("''","'",$result["gra_note"]);
		$result["gra_blob"] = ereg_replace("''","'",$result["gra_blob"]);
	}

	return $result;
}

# --------------------------------
# Store a new graph:
# --------------------------------
function StoreGraph($name,$note,$graph,$w,$h)
{
	$w     = SQLMakeIntSafe($w);
	$h     = SQLMakeIntSafe($h);
	$name  = addslashes($name);
	$note  = addslashes($note);
	$graph = addslashes($graph);
	
	$date = DateUnixToDB(time());

	// +++++ added on the 22 Aug 2003:
	if ($this->m_dbtype == "Sybase") {
		$name  = ereg_replace("\\\'","''",$name);
		$note  = ereg_replace("\\\'","''",$note);
		$graph = ereg_replace("\\\'","''",$graph);
	}

	// +++++ changed on the 22 Aug 2003 to take care of PostgreSQL 'nextval':
	if ($this->m_dbtype == "PostgreSQL") {
		$query = "INSERT INTO t_benchmark_graph (gra_id,gra_name,gra_date,gra_note,gra_blob,gra_width,gra_height) ".
					"VALUES (NEXTVAL('gra_id_seq'),'$name','$date','$note','$graph',$w,$h)";
	}
	else {
		$query = "INSERT INTO t_benchmark_graph (gra_name,gra_date,gra_note,gra_blob,gra_width,gra_height) ".
					"VALUES ('$name','$date','$note','$graph',$w,$h)";
	}
				
	$res = $this->m_int->QueryExecute($query);
	
	return $res;
}

# --------------------------
# Delete the specified Graph:
# --------------------------
function GraphDelete($grid)
{
	$grid = SQLMakeIntSafe($grid);
	
	$query = "DELETE FROM t_benchmark_graph WHERE gra_id = $grid";

	$res = $this->m_int->QueryExecute($query);
	
	return $res;
}

#
# =================================================
# Function needed to compute statistics:
# =================================================
#
function SetStartDate($startdate) 	{ $this->m_startdate = $startdate; }
function SetEndDate($enddate) 		{ $this->m_enddate = $enddate; }
function SetRequest($req) 			{ $this->m_filterurl = $req; }
function SetServers($servers) 		{ $a = explode(".",$servers); $this->m_servers = ($a[0] << 24) + ($a[1] << 16) + ($a[2] << 8) + $a[3]; }
function SetProtocols($proto) 		{ $this->m_protocols = $proto; }
function SetThreshold($t) 			{ $this->m_threshold = $t; }

function CheckDateRange($year1,$month1,$day1,$year2,$month2,$day2)
{
	if ($year1 > $year2 ||
	    ($year1 == $year2 && $month1 > $month2) ||
	    ($year1 == $year2 && $month1 == $month2 && $day1 > $day2))
	    	return 0;
	
	return 1;
}

function NextDay($curday)
{
	list($year,$month,$day) = split("[- ]",$curday);
	$nextday = mktime(0,0,0,$month,$day,$year) + 3600 * 24;
	return strftime("%Y-%m-%d",$nextday);
}

# -------------------------------------------------
# Helper functions used to build the requests:
# -------------------------------------------------
function AddAvgFilter($stat)
{
	// always add the date constraint:
	$filter = " AND ".$this->m_int->DateCompare("log_date",$this->m_startdate,$this->m_enddate);

	// and now the optional filters:
	if ($this->m_threshold) 
		# fixed on the 30 July 2003
		#$threshold .= " AND (ben_sec * 1000 + ben_usec / 1000) > $this->m_threshold";
		$filter .= " AND (ben_sec * 1000 + ben_usec / 1000) > $this->m_threshold";

	if ($this->m_filterurl != "all" && !empty($this->m_filterurl))
		$filter .= " AND url_value = \"$this->m_filterurl\"";

	if ($this->m_servers != "all" && !empty($this->m_servers))
		# fixed on the 30 July 2003:
		#$filter .= " AND ben_srvaddr = ".ip2long($this->m_servers);
		$filter .= " AND ben_srvaddr = ".$this->m_servers;

	if ($stat != "alert" && $this->m_protocols != "all" && !empty($this->m_protocols))
		$filter .= " AND ben_srvport = ".$this->m_protocols;

	return $filter;
}

function AddMaxFilter($stat)
{
	return $this->AddAvgFilter($stat);
}

function AddMinFilter($stat)
{
	return $this->AddAvgFilter($stat);
}

# =================================================
# GENERIC MAX STATISTICS
# =================================================
function GetStat($stat,$stattype,$scale)
{
	# Get the query basis:
	if ($stattype == "max") {
		$query = $this->m_maxQuery[$stat];
		$filter = $this->AddMaxFilter($stat);
	}
	else if ($stattype == "avg") {
		$query = $this->m_avgQuery[$stat];
		$filter = $this->AddAvgFilter($stat);
	}
	else if ($stattype == "min") {
		$query = $this->m_minQuery[$stat];
		$filter = $this->AddAvgFilter($stat);
	}
	else {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GetStat() bad stattype: $stattype");
		return 0;
	}
		
	# The scale gives the loop count and the specific clause:
	$startcount = 0;
	if ($scale == "minute" || $scale == "hour") 
		$maxcount = 59;
	else if ($scale == "day")
		$maxcount = 23;
	else if ($scale == "week") {
		$startcount = 1;
		$maxcount = 7;
	}
	else if ($scale == "month") {
		list($year,$month,$day) = split("[- ]",$this->m_startdate);
		$maxcount = $this->DayPerMonth($month,$year);
		$startcount = 1;
	}
	else if ($scale == "year") {
		$startcount = 1;
		$maxcount = 12;
	}
	else {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GetStat() bad scale: $scale");
		return 0;
	}
	
	# Loop on the interval:
	for ( $idx = $startcount ; $idx <= $maxcount ; $idx++ ) {

		$q = $query;
		
		if ($scale == "minute") 
			$q .= " WHERE ".$this->m_int->GetSecondPart("log_date")." = $idx";
		else if ($scale == "hour")
			$q .= " WHERE ".$this->m_int->GetMinutePart("log_date")." = $idx";
		else if ($scale == "day")
			$q .= " WHERE ".$this->m_int->GetHourPart("log_date")." = $idx";
		else if ($scale == "week")
			$q .= " WHERE ".$this->m_int->GetDayOfWeek("log_date")." = $idx";
		else if ($scale == "month")
			$q .= " WHERE ".$this->m_int->GetDayOfMonth("log_date")." = $idx";
		else if ($scale == "year")
			$q .= " WHERE ".$this->m_int->GetMonth("log_date")." = $idx";

		$q .= $filter;

		//echo $q;
		$res = $this->m_int->QueryAndFetchaRow($q);
		if (!$res) {
			$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::GetStat($stat) failed");
			return 0;
		}

		$result[$idx-$startcount] = $res["value"];
	}

	return $result;
}

# =================================================
# AVERAGE STATISTICS
# =================================================
# -------------------------------------------------
# Statistics per MINUTE:
# -------------------------------------------------
function AvgStatPerMinute($stat)
{
	$query = $this->m_avgQuery[$stat];

	for ( $idx = 0 ; $idx <= 59 ; $idx++ ) {

		$q = $query;
		$q .= " WHERE ".$this->m_int->GetSecondPart("log_date")." = $idx";
		$q .= $this->AddAvgFilter($stat);

		$res = $this->m_int->QueryAndFetchRows($q);
		if (!$res) {
			$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::AvgStatPerMinute($stat) failed");
			return 0;
		}

		$result[$idx] = $res["value"];
	}

	return $result;
}

# -------------------------------------------------
# Statistics per HOUR:
# -------------------------------------------------
function AvgStatPerHour($stat)
{
	$query = $this->m_avgQuery[$stat];

	for ( $idx = 0 ; $idx <= 23 ; $idx++ ) {

		$q  = $query;
		$q .= " WHERE ".$this->m_int->GetHourPart("log_date")." = $idx";
		$q .= $this->AddAvgFilter($stat);

		$res = $this->m_int->QueryAndFetchaRow($q);
		if (!$res) {
			$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::StatPerHour($idx) failed");
			return 0;
		}

		$result[$idx] = $res["value"];
	}

	return $result;
}

# -------------------------------------------------
# Statistics per DAY of WEEK:
# -------------------------------------------------
function AvgStatPerDayOfWeek($stat)
{
	$query = $this->m_avgQuery[$stat];

	for ( $idx = 1 ; $idx <= 7 ; $idx++ ) {

		$q  = $query;
		$q .= " WHERE ".$this->m_int->GetDayOfWeek("log_date")." = $idx";
		$q .= $this->AddAvgFilter($stat);

		$res = $this->m_int->QueryAndFetchaRow($q);
		if (!$res) {
			$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::StatPerDayOfWeek($idx) failed");
			return 0;
		}

		$result[$idx] = $res["value"];
	}

	return $result;
}

# -------------------------------------------------
# Statistics per WEEK:
# -------------------------------------------------
function AvgStatPerWeek($stat)
{
	$query = $this->m_avgQuery[$stat];

	for ( $idx = 1 ; $idx <= 52 ; $idx++ ) {

		$q  = $query;
		$q .= " WHERE ".$this->m_int->GetWeek("log_date")." = $idx";
		$q .= $this->AddAvgFilter($stat);

		$res = $this->m_int->QueryAndFetchaRow($q);
		if (!$res) {
			$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::StatPerWeek($idx) failed");
			return 0;
		}

		$result[$idx] = $res["value"];
	}

	return $result;
}

# -------------------------------------------------
# Statistics per DAY OF MONTH:
# -------------------------------------------------
function DayPerMonth($month,$year)
{
	switch ((int)$month) {
	case 1: case 3: case 5: case 7: case 8: case 10: case 12: $daycount = 31; break;
	case 4: case 6: case 9: case 11: $daycount = 30; break;
	case 2: if (((int)$year % 4) == 0 && ((int)$year % 100)) $daycount = 29; else $daycount = 28;
	}
	
	return $daycount;
}

function AvgStatPeraDay($stat,$year,$month,$day)
{
	$query = $this->m_avgQuery[$stat];

	$q  = $query;
	$q .= " WHERE ".$this->m_int->GetDayOfMonth("log_date")." = $day AND ".
	 		$this->m_int->GetYear("log_date")." = $year AND ".
			$this->m_int->GetMonth("log_date")." = $month";
			$q .= $this->AddAvgFilter($stat);

	$res = $this->m_int->QueryAndFetchaRow($q);
	if (!$res) {
		$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::StatPeraDay($year,$month,$day) failed");
		return 0;
	}

	return $res["value"];
}

function AvgStatPerDayRange($stat,$year1,$month1,$day1,$year2,$month2,$day2)
{
	if (!$this->CheckDateRange($year1,$month1,$day1,$year2,$month2,$day2))
		return 0;

	$startdate = $year1."-".$month1."-".$day1;
	$enddate   = $year2."-".$month2."-".$day2;
	$count     = 1;

	while ($year1 < $year2 ||
	       ($year1 == $year2 && $month1 < $month2) ||
	       ($year1 == $year2 && $month1 == $month2 && $day1 <= $day2)) {
		list($year,$month,$day) = split("[- ]",$startdate);
		$res[$count] = $this->AvgStatPeraDay($stat,$year,$month,$day);
		$count++;
		#echo $startdate."<br>";
		$startdate = $this->NextDay($startdate);
		#echo $startdate."<br>";
		list($year1,$month1,$day1) = split("[- ]",$startdate);
		#echo $year1." ".$month1." ".$day1."<br>\n";
	}

	return $res;
}

function AvgStatPerDayOfMonth($stat)
{
	list($year,$month,$day) = split("[- ]",$this->m_startdate);
	$daycount = $this->DayPerMonth($month,$year);

	$result = $this->AvgStatPerDayRange($stat,$year,$month,1,$year,$month,$daycount);

	return $result;
}

# -------------------------------------------------
# Statistics per MONTH:
# -------------------------------------------------
function AvgStatPerMonth($stat)
{
	$query = $this->m_avgQuery[$stat];

	list($year,$month,$day) = split("[- ]",$this->m_startdate);

	for ( $idx = 1 ; $idx <= 12 ; $idx++ ) {

		$q  = $query;
		$q .= " WHERE ".$this->m_int->GetMonth("log_date")." = $idx AND ".
				$this->m_int->GetYear("log_date")." = $year";
		$q .= $this->AddAvgFilter($stat);

		$res = $this->m_int->QueryAndFetchaRow($q);
		if (!$res) {
			$this->m_int->SQLErrorLog($this->m_db.": CDBBenchmark::StatPerMonth($year) failed");
			return 0;
		}

		$result[$idx] = $res["value"];
	}

	return $result;
}

# -------------------------------------------------
# Statistics for LAST 30 DAYS:
# -------------------------------------------------
function AvgStatPerLast30d($stat,$y1,$m1,$d1,$y2,$m2,$d2)
{
	return $this->StatPerDayRange($stat,$y1,$m1,$d1,$y2,$m2,$d2);
}

}; // end of class

?>
