<!-- REQUIREMENT -->
<table width=100% bordercolor="#003399" border=1 cellspacing=0 cellpadding=3>
    <tr height=20> 
	    <td colspan=2 class=paramtitleright><a name=Requirement>&nbsp;Requirement</a></td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			This version of <?php echo $gModuleName ?> requires the following items:<br><br>
			<ul>
				<li>System: Linux 2.2.x/2.4.x</li>
				<li>Apache: 1.3.x/2.0.x</li>
				<li>Database: MySQL 3/4, Sybase (tested on 11.9.2)</li>
				<li>Third-Party: PHP 4.x</li>
				<li>Browser: MS-IE 4/5/6, Netscape, Konqueror... with the SVG Viewer plug-in 
							(available at <a href="http://www.adobe.com">http://www.adobe.com</a>)</li>
			</ul>
		</td>
	</tr>
</table>
<br>

<!-- INSTALLATION-->
<table width=100% bordercolor="#003399" border=1 cellspacing=0 cellpadding=3>
    <tr height=20> 
	    <td colspan=2 class=paramtitleright><a name=Installation>&nbsp;Installation</a></td>
	</tr>
	<tr valign=top>
		<td width=15% class=textstd>
			<p class=text10b><br>1-Compilation</p>
		</td>
		<td class=textstd>
			<ul>
				<li>
					Get the <?php echo $gModuleName ?> archive (mod_benchmark-1.6.tar.gz) and expand it under
					a directory (for example /usr/local/)<br>
					<br>
				</li>
				<li>
					Run "./configure" with at least one of these options to enable a Database interface:<br>
					<br>
					--enable-mysql&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;or <br>
				    --enable-sybase<br>
					<br>
				    and one of the two following options depending on your Apache server version:<br>
					<br>
        			--with-apxs=[path to apxs]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(for Apache 1.x) or<br>
     				--with-apxs2=[path to apxs]&nbsp;&nbsp;&nbsp;&nbsp;(for Apache 2.x)<br>
					<br>
     				<span style='font-weight: bold;'>Example:</span><br>
     				<br>
				    ./configure --enable-mysql --with-mysqldir=/usr/include/mysql --with-apxs=/usr/sbin/apxs<br>
					<br>
					Note that "--with-mysqldir=[dir]" or "--with-sybasedir=[dir]" options must also be indicated
					to indicate the path to the related include files.<br>
					<br>
				</li>
				<li>
					Run "make"<br>
					<br>
				</li>
				<li>
					Run "make install"<br>
				   	Since the Makefile has been created by apxs, it will try to copy
   					the module and its related file under the Apache module directory.<br>
					<br>
				</li>
				<li>
					Check that the following new files have been copied under the Apache module
   					directory:<br><br>
					<table class=textstd cellspacing=5>
						<tr>
							<td class=textstdblue>mod_benchmark.so</td>
							<td>THE Apache module</td>
						</tr>
						<tr>
							<td class=textstdblue>benchmark-mysql.so (optional)</td>
							<td>interface between the module and MySQL database</td>
						</tr>
						<tr>
							<td class=textstdblue>benchmark-sybase.so (optional)</td>
							<td>interface between the module and SYBASE database</td>
						</tr>
					</table>
   					<br>
					If you want to interface <?php echo $gModuleName ?> with another Database Manager,
					contact us at <a href="mailto:support@trickytools.com">support@trickytools.com</a><br>
					<br>
				</li>
				<li>
					The "benchmark" directory contains all the files needed by the "Control Panel".<br>
					You must copy this directory where you want under Apache server tree. For example:<br>
					<br>
					# cp -r benchmark /usr/local/httpd<br>
					<br>
					Then change the owner and group of the newly created "benchmark" directory to reflect
					the values normally used by your Apache Server. For example:<br>
					<br>
					# cd /usr/local/httpd<br>
					# chown -R wwwrun.wwwgrp benchmark<br>
					# chmod -R og-rwx benchmark<br>
				</li>
			</ul>
		</td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			<p class=text10b><br>2-Database Tables Creation</p>
		</td>
		<td class=textstd>
			<?php echo $gModuleName ?> will log the measured requests and the alerts in a Database.<br>
			You can use an existing Database or create a new one.<br>
			<br>
			<ul>
				<li>
					Choose or create a database<br>
					<br>
				</li>
				<li>
					Run the "sql/mod_benchmark-mysql.sql" or "sql/mod_benchmark-sybase.sql" script 
   					to create the tables in the Database.<br>
					<br>
				</li>
				<li>
					Create a user/passwd that can access these tables with the INSERT,SELECT and DELETE 
					access rights.<br>
					<br>
				</li>
				<li>
					Go to the "benchmark" directory created under Apache server tree, 
					then edit "yourglobals.inc.php" file.<br>
					This file contains several global parameters that can be customized. In particular,
					you must indicate the four parameters needed by the PHP scripts to connect to the Database.<br>
				</li>
			</ul>
		</td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			<p class=text10b><br>3-Apache Configuration</p>
		</td>
		<td class=textstd>
			<ul>
				<li>
					Edit <?php echo $gHTTPConf ?> file and add the directives for <?php echo $gModuleName ?><br>
					(see <a href="#Directives">below</a>)<br>
					<br>
				</li>
				<li>
					Restart Apache.<br>
					<br>
					If the server does not restart successfully, 
					consult the <a href="#Troubleshooting">troubleshooting</a> section.<br>
				</li>
			</ul>
		</td>
	</tr>
</table>
<br>

<!-- APACHE DIRECTIVES -->
<table width=100% bordercolor="#003399" border=1 cellspacing=0 cellpadding=3>
    <tr height=20> 
	    <td colspan=2 class=paramtitleright><a name=Directives>&nbsp;Apache Directives</a></td>
	</tr>
	<tr valign=top>
		<td width=15% class=textstd>
			<p class=text10b><br>1-Loading the Apache Module</p>
		</td>
		<td class=textstd>
			First of all, you must make sure <?php echo $gModuleName ?> is loaded by the Apache Server. You must add the
			two following lines in your <?php echo $gHTTPConf ?> file:<br>
			<br>
			<span class=texttech>
			LoadModule benchmark_module /path_to_apache_modules/mod_benchmark.so<br>
			AddModule mod_benchmark.c
			</span>
			<br><br>
			<?php echo $gModuleName ?> behaviour can be customized using the following Apache directives:<br>
		</td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			<p class=text10b><br>2-Server Level Directives</p>
		</td>
		<td class=textstd>
			<table width=100% cellpadding=3 cellspacing=0 border=1>
				<tr>
					<td class=texttech valign=top>LogFormat</td>
					<td class=textstd>
						<?php echo $gModuleName ?> defines two new variables that can be used to add information 
						to the request log:<br><br>
						<span class=texttech>BenchmarkElapsed</span> which gives the elapsed time to answer 
						the request. The time format is "seconds.micro-seconds"<br>
						<span class=texttech>BenchmarkScoreBoard</span> gives the count of ready and 
						busy Apache instances at the request time. 
					</td>
				</tr>
				<tr>
					<td class=texttech valign=top>BenchmarkTrace</td>
					<td class=textstd>
						<span class=text10>Value: debug</span><br><br>
						Sets the module in "debug" mode. Debug messages will be added to the Apache error log. 
					</td>
				</tr>
				<tr>
					<td class=texttech valign=top>BenchmarkUseScoreBoard</td>
					<td class=textstd>
						<span class=text10>Value: on|off</span><br><br>
						Using the Apache scoreboard makes each request logged with the count of ready and busy 
						Apache instances at the time it was required by the client. 
						Logging this information can be useful if you want to correlate the response time 
						with the system load. 					
					</td>
				</tr>
				<tr>
					<td class=texttech valign=top>BenchmarkStore</td>
					<td class=textstd>
						<span class=text10>Value: /path_to_db_interface.so:dbserver:dbname:dbuser:dbpwd</span><br><br>
						Each request measured by <?php echo $gModuleSQLScript ?> can be logged in the Apache log 
						(using the LogFormat directive) and/or can be stored in a database.<br>
						To store the requests in a Database, you must specify the interface for this 
						Database (MySQL, Sybase...), 
						and then the four parameters that allow the module to connect and store data 
						in the database tables.<br>
						Normally, the tables have been created from the <?php echo $gModuleSQLScript ?> script. 
					</td>
				</tr>
				<tr>
					<td class=texttech valign=top>BenchmarkWithSysInfo</td>
					<td class=textstd>
						<span class=text10>Value: on|off:statprogram:socketname:interval</span><br><br>
						For each measured request, the module can also store the current system 
						load and memory usage. Logging this information can be useful if you want to 
						correlate the response time with the system load.<br>
						If you specify the "on" value, <?php echo $gModuleName ?> will start the <?php echo $gSysstatProc ?> 
						process at launch time. This process will then communicate with the module 
						using the "socketname" Unix socket and will compute the system load at 
						each "interval" seconds. <?php echo $gSysstatProc ?> will be automatically stopped when Apache stops. 
					</td>
				</tr>
				<tr>
					<td class=texttech valign=top>BenchmarkAlertAction</td>
					<td class=textstd>
						<span class=text10>Value: proc</span><br><br>
						Each time a request will overrun the threshold specified by the 
						"BenchmarkAlertLimit" directive (see below), it will run the external "proc" 
						program with the request and the response time (in milliseconds) as arguments. 
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			<p class=text10b><br>3-Directory / Location Level Directives</p>
		</td>
		<td class=textstd>
			<table width=100% cellpadding=3 cellspacing=0 border=1>
				<tr>
					<td class=texttech valign=top>BenchmarkEngine</td>
					<td class=textstd>
						<span class=text10>Value: on|off</span><br><br>
						Activate or desactivate the module for the current Directory/Location 
					</td>
				</tr>
				<tr>
					<td class=texttech valign=top>BenchmarkAccept</td>
					<td class=textstd>
						<span class=text10>Value: regexp</span><br><br>
						Regular expression that filters the URI to handle.<br>
						For example, if you want to measure PHP and PL scripts only, specify:<br><br>
						<span class=texttech>BenchmarkAccept \.php$|\.pl$</span>
					</td>
				</tr>
				<tr>
					<td class=texttech valign=top>BenchmarkAlertLimit</td>
					<td class=textstd>
						<span class=text10>Value: threshold</span><br><br>
						If you insert a "BenchmarkAlertAction" direction (see above), 
						you can specify the "threshold" (in milliseconds) for the generated alerts.  
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			<p class=text10b><br>4-Configuration Sample</p>
		</td>
		<td class=textstd>
			...<br>
			LoadModule benchmark_module /usr/lib/apache/mod_benchmark.so<br>
			AddModule mod_benchmark.c<br>
			... <br>
			LogFormat "%t %{BenchmarkElapsed}n %{BenchmarkScoreBoard}n \"%r\" %s %B" benchmark_log<br>
			CustomLog logs/benchmark.log benchmark_log<br>
			... <br>
			#BenchmarkTrace debug<br>
			BenchmarkUseScoreBoard on<br>
			<br>
			# use the MySQL interface:
			BenchmarkStore /usr/lib/apache/benchmark-mysql.so:localhost:benchmark:wwwrun:wwwpwd<br>
			<br>
			BenchmarkWithSysInfo on:/opt/apache/mod_benchmark/sysstat2:/tmp/bench:5<br>
			BenchmarkAlertAction /opt/apache/mod_benchmark/alerter.sh<br>
			...<br>
			&lt;Location /scripts&gt;<br>
				&nbsp;&nbsp;&nbsp;&nbsp;BenchmarkEngine on<br>
				&nbsp;&nbsp;&nbsp;&nbsp;BenchmarkAccept \.html$|\.php$<br>
				&nbsp;&nbsp;&nbsp;&nbsp;BenchmarkAlertLimit 200<br>
			&lt;/Location&gt;<br><br>
		</td>
	</tr>
</table>
<br>

<!-- TESTING -->
<table width=100% bordercolor="#003399" border=1 cellspacing=0 cellpadding=3>
    <tr height=20> 
	    <td colspan=2 class=paramtitleright><a name=Testing>&nbsp;Testing</a></td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			<p class=text10b><br>1-Testing Apache Server</p>
		</td>
		<td class=textstd>
			<ul>
				<li>
					Using your favorite browser, navigate through any location handled by
  					<?php echo $gModuleName ?> (this location should be located under a &lt;Location&gt; block
					where the "BenchmarkEngine" directive is "on" and the "BenchmarkAccept"
					directive filters the requested URI)<br>
					<br>
				</li>
				<li>
					Connect to the Database and check one row has been inserted for each request
					in the "t_benchmark_log" table.<br>
					If not, check the error logs (Apache, MySQL, system...) and fix the bug.<br>
					(or take a look at the <a href="#Troubleshooting">Troubleshooting</a> section)<br>
				</li>
			</ul>
		</td>
	</tr>
	<tr valign=top>
		<td class=textstd>
			<p class=text10b><br>2-Testing the Control Panel</p>
		</td>
		<td class=textstd>
			<ul>
				<li>
					Still with your browser navigate to the newly created "benchmark" subdir.<br>
					<br>
				</li>
				<li>
					If your Apache server is configured to automatically return the "index.html"
					file, you will see the control panel, otherwise, click on "index.html" file
				</li>
				<li>
					The Control Panel should be displayed without any PHP error.<br>
					Use the default values except for the "Duration": select the "one Hour" scale.<br>
					<br>
					Click on "Get Report" menu option.<br>
					<br>
				</li>
				<li>
					A graph should appear in the right pane of the Control Panel !!! Congratulations.<br>
					<br>
				  	Otherwise, there is a Database or PHP misconfiguration.<br>
					The error message should be explicit enough, but you can consult
					the <a href="#Troubleshooting">Troubleshooting</a> section.<br>
				</li>
			</ul>
		</td>
	</tr>
</table>
<br>

<!-- CONTROL PANEL -->
<table width=100% bordercolor="#003399" border=1 cellspacing=0 cellpadding=3>
    <tr height=20> 
	    <td colspan=2 class=paramtitleright><a name=Panel>&nbsp;Control Panel</a></td>
	</tr>
	<tr valign=top>
		<td width=15% class=textstd>
			<p class=text10b><br>1-Menu Option</p>
		</td>
		<td class=textstd>
			<table width=90% align=center border=1 cellspacing=0 cellpadding=3>
				<tr>
					<td valign=top width=20% class=text10>Get Report</td>
					<td class=textstd>
						Generate a graphical or tabular Report from the benchmark log and using the specified
					    parameters
					</td>
				</tr>
				<tr>
					<td  valign=top class=text10>Server Stats</td>
					<td class=textstd>
						Display the interface used to generate "server-oriented" Reports.<br>
						On these reports you can compare Servers permformance, since you can select
						multiple Servers in the appropriate List Box.
					</td>
				</tr>
				<tr>
					<td  valign=top class=text10>Indicator Stats</td>
					<td class=textstd>
						Display the interface used to generate "indicator-oriented" Reports.<br>
						On these reports you can view simultaneous indicators, since you can select
						multiple Indicator in the appropriate List Box.
					</td>
				</tr>
				<tr>
					<td  valign=top class=text10>Send Graph</td>
					<td class=textstd>
						Display a form that allow you to e-mail the current Report
					</td>
				</tr>
				<tr>
					<td  valign=top class=text10>Load a Graph</td>
					<td class=textstd>
						Display a form that allow you display a previously saved Report
					</td>
				</tr>
				<tr>
					<td  valign=top class=text10>Save Graph</td>
					<td class=textstd>
						Display a form that allow you save the current Report
					</td>
				</tr>
				<tr>
					<td  valign=top class=text10>Help !</td>
					<td class=textstd>
						Display this help !
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr valign=top>
		<td width=15% class=textstd>
			<p class=text10b><br>2-Available Statistics</p>
		</td>
		<td class=textstd>
			<table width=90% align=center border=1 cellspacing=0 cellpadding=3>
				<tr>
					<td valign=top width=20% class=text10>Response Time</td>
					<td class=textstd>
						This indicator gives the time (expressed in milliseconds) needed by the Server
						to generate a Request Response.
					</td>
				</tr>
				<tr>
					<td valign=top width=20% class=text10>CPU Load</td>
					<td class=textstd>
						The CPU Load is computed in real-time by the <?php echo $gSysstatProc ?> helper process.<br>
						This indicator is available if "BenchmarkWithSysInfo" directive is set to "on".
					</td>
				</tr>
				<tr>
					<td valign=top width=20% class=text10>Apache Load</td>
					<td class=textstd>
						Apache Load is given by Apache Scoreboard. This indicator reflects the count of busy
						instances of Apache servers when the request is handled.<br>
						This indicator is available if "BenchmarkUseScoreBoard" directive is set to "on".
					</td>
				</tr>
				<tr>
					<td valign=top width=20% class=text10>Memory Use</td>
					<td class=textstd>
						The percentage of used Memory is computed in real-time by the <?php echo $gSysstatProc ?> 
						helper process.<br>
						This indicator is available if "BenchmarkWithSysInfo" directive is set to "on".
					</td>
				</tr>
				<tr>
					<td valign=top width=20% class=text10>Swap Use</td>
					<td class=textstd>
						The percentage of used Swap is computed in real-time by the <?php echo $gSysstatProc ?> 
						helper process.<br>
						This indicator is available if "BenchmarkWithSysInfo" directive is set to "on".
					</td>
				</tr>
				<tr>
					<td valign=top width=20% class=text10>Alert Count</td>
					<td class=textstd>
						This indicator gives the count of sent alerts. Alerts are generated when the Response
						Time for a request is greater than the Threshold specified by "BenchmarkAlertLimit" directive.
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr valign=top>
		<td width=15% class=textstd>
			<p class=text10b><br>3-Other Parameters</p>
		</td>
		<td class=textstd>
			In the main area, where the graph is displayed, you can use the following controls 
			to refine the generated Report:<br>
			<br>
			<table width=90% align=center border=1 cellspacing=0 cellpadding=3>
				<tr>
					<td valign=top width=25% class=text10>Average CheckBox</td>
					<td class=textstd>
						Display the average value of the selected inficators or servers.<br><br>
						To generate a Report, you must select at least one of the following	checkbox.
					</td>
				</tr>
				<tr>
					<td valign=top width=25% class=text10>Min CheckBox</td>
					<td class=textstd>
						Display the minimum value of the selected inficators or servers.
					</td>
				</tr>
				<tr>
					<td valign=top width=25% class=text10>Min CheckBox</td>
					<td class=textstd>
						Display the maximum value of the selected inficators or servers.
					</td>
				</tr>
				<tr>
					<td valign=top width=25% class=text10>Zoom</td>
					<td class=textstd>
						You can display the Report in a new popup window by pressing the "Zoom" Icon.<br>
						The new graph will be displayed in respect of the indicated "Zoom Factor".
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
<br>

<!-- TROUBLESHOOTING -->
<table width=100% bordercolor="#003399" border=1 cellspacing=0 cellpadding=3>
    <tr height=20> 
	    <td colspan=2 class=paramtitleright><a name=Troubleshooting>&nbsp;Troubleshooting</a></td>
	</tr>
	<tr valign=top>
		<td width=20% class=textstd>
			<p class=text10b><br>1-Installation Error</p>
		</td>
		<td class=textstd>
			<br>
			<ul>
				<li>
					This section needs to be completed...<br>
					<br>
				</li>
				<li>
					Usually, compilation problems can be solved by setting the appropriate arguments 
					to the "./configure" command.<br>
					Especially, do not forget to precise the Include directory of the Database library using
					the "--withXXXXDir=[...]" option.
				</li>
			</ul>
		</td>
	</tr>
	<tr valign=top>
		<td width=20% class=textstd>
			<p class=text10b><br>2-Apache Error</p>
		</td>
		<td class=textstd>
			<br>
			<ul>
				<li>
					When errors occur when Apache is restarted, check the "rcapache.log" file or the
					Apache error log file.<br>
					<br>
				</li>
				<li>
					Check Apache could find the ".so" modules.<br>
					<br>
				</li>
				<li>
					Check Apache could load the ".so" modules.<br>
					The test can be done by statically linking with the ".so" and check the linker errors.<br>
					<br>
				</li>
				<li>
					Comment the "Benchmark" directive in <?php echo $gHTTPConf ?> file and restart.<br>
					Uncomment directives one per one to find the wrong one.<br>
				</li>
			</ul>
		</td>
	</tr>
	<tr valign=top>
		<td width=20% class=textstd>
			<p class=text10b><br>3-Runtime Error</p>
		</td>
		<td class=textstd>
			<br>
			<ul>
				<li>
					The Database Tables are not filled when a Request is made to a benchmarked URL ?<br>
					<br>
					Check the "Benchmark" directives<br>
					<br>
				</li>
				<li></li>
					If Database problem persist, check the Database error log.<br>
					<br>
					Database interfaces have been coded to write the Database errors in Apache "stderr" file.<br>
				</li>
			</ul>					
		</td>
	</tr>
	<tr valign=top>
		<td width=20% class=textstd>
			<p class=text10b><br>4-Control Panel Error</p>
		</td>
		<td class=textstd>
			<br>
			<ul>
				<li>
					Check Apache has the good access rights to the "benchmark" directory<br>
					<br>
				</li>
				<li>
					Check content of "yourglobals.inc.php" file<br>
					<br>
				</li>
				<li>
					Make sure your Browser supports SVG format !<br>
				</li>
			</ul>
		</td>
	</tr>
</table>
<br></b>
