<?php
#
# ====================================================================
#
# Display a graph
#
# Date: 20 September 2002
# Author: J.Delamarche
# Version: 1.5
#
# Input Parameters:	
#		graph
#
# Output: 		display the graph manager
#
# --------------------------------------------------------------------
#
# TODO:
#
# ====================================================================
#
include_once "util.inc.php";
include_once "dbbenchmark.inc.php";

$gGraphID = SetParmValue("graph");

$db = new CDBBenchmark($dbtype,$dbname,$dbserver,$dbuser,$dbpwd);

# check if operation is required:
if (empty($gGraphID)) {
	$onLoad = "No Graph specified !";
}
else {
	$agraph = $db->GraphGet($gGraphID);
	if (!$agraph) {
		// an error occurred !
		$onLoad = "JavaScript: alert('Requested Graph could not be found in Database !');";
	}
	else {
		// compute a temporary filename:
		$imgname = GetImageName("svg");

		$fd = fopen($imgname["local"],"w");
		fwrite($fd,$agraph["gra_blob"]);
		fclose($fd);
		
		$w = $agraph["gra_width"] + 90;
		$h = $agraph["gra_height"] + 130;
		$onLoad = "JavaScript: window.resizeTo($w,$h);";
	}
}
?>
<html>
<head>
	<title>View a Graph</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<link rel="stylesheet" type="text/css" href="cpanel.css">
</head>

<body onLoad="<?php echo $onLoad ?>">
<table width=100% cellspacing=0 cellpadding=3 border=0>
<tr>
<td bgcolor="<?php echo $gLeftLogoBgColor ?>" width=60 valign=top><img src="<?php echo $gLeftLogo ?>" border=0 height=300></td>
<td>
	<table width=100%>
		<tr>
			<td colspan=2 align=center valign=top class=paramtitle><?php echo $agraph["gra_name"] ?></td>
		</tr>
		<tr>
			<td width=20% class=text10b align=right>Creation Date:</td>
			<td width=80% class=textstd><?php echo $agraph["gra_date"] ?></td>
		</tr>
		<tr>
			<td class=text10b align=right>Note:</td>
			<td class=textstd valign=top><textarea rows=2 class=inputtext2 cols=60><?php echo $agraph["gra_note"] ?></textarea></td>
		</tr>
		<tr>
			<td colspan=2>
				<embed name=graph type="image/svg" 
					pluginspage="http://www.adobe.com/svg/viewer/install/"
					src="<?php echo $imgname["remote"] ?>"
					width="<?php echo $agraph["gra_width"] ?>"
					height="<?php echo $agraph["gra_height"] ?>">
				</embed>
			</td>
		</tr>
	</table>
</td>
</tr>
</table>
</body>
</html>
